## rocksdb 9.2.1

=== debian/changelog ===
rocksdb (9.2.1-3) unstable; urgency=medium

  [ wuruilong <wuruilong@loongson.cn> ]
  * Fix compilation options for loong64 architecture (closes: #1072547).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 08 Jun 2024 21:20:56 +0000

rocksdb (9.2.1-2) unstable; urgency=medium

  * Upload to Sid.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 02 Jun 2024 21:34:43 +0200

rocksdb (9.2.1-1) experimental; urgency=medium

  * New major upstream release.
  * Library transition from librocksdb9.1 to librocksdb9.2 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 31 May 2024 17:32:44 +0200

rocksdb (9.1.1-1) experimental; urgency=medium

  * New upstream release.
  * Update Standards-Version to 4.7.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 24 Apr 2024 18:03:57 +0200

rocksdb (9.1.0-1) experimental; urgency=medium

  * New major upstream release.
  * Library transition from librocksdb9.0 to librocksdb9.1 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 20 Apr 2024 09:25:47 +0200

rocksdb (9.0.0-1) experimental; urgency=medium

  * New major upstream release.
  * Library transition from librocksdb8.11 to librocksdb9.0 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 25 Mar 2024 18:21:02 +0100

rocksdb (8.11.3-1) experimental; urgency=medium

  * New major upstream release.
  * Library transition from librocksdb8.10 to librocksdb8.11 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 05 Mar 2024 17:17:47 +0100

rocksdb (8.10.2-1) experimental; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 27 Feb 2024 17:58:06 +0100

rocksdb (8.10.0-1) experimental; urgency=medium

  * New major upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 14 Jan 2024 20:56:41 +0100

=== debian/control ===
Source: rocksdb
Section: database
Priority: optional
Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
Build-Depends: debhelper-compat (= 13), cmake, libgflags-dev, libsnappy-dev,
 libbz2-dev, zlib1g-dev, liblz4-dev, libzstd-dev
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://rocksdb.org/

Package: librocksdb-dev
Section: libdevel
Architecture: amd64 arm64 armel armhf loong64 ppc64el mips mipsel mips64el s390x i386 riscv64
Depends: ${misc:Depends}, librocksdb9.2 (= ${binary:Version}), libgflags-dev,
 libsnappy-dev, libbz2-dev, zlib1g-dev, liblz4-dev, libzstd-dev
Description: persistent Key-Value Store for Flash and RAM Storage (development)
 C++ library providing an embedded key-value store, where keys and values are
 arbitrary byte streams. It was developed at Facebook based on LevelDB and
 provides backwards-compatible support for LevelDB APIs.
 .
 RocksDB is optimized for Flash with extremely low latencies. RocksDB uses a
 Log Structured Database Engine for storage, written entirely in C++.
 .
 RocksDB features highly flexible configuration settings that may be tuned to
 run on a variety of production environments, including pure memory, Flash,
 hard disks or HDFS. It supports various compression algorithms and good tools
 for production support and debugging.
 .
 Features:
   - Designed for application servers wanting to store up to a few terabytes
     of data on locally attached Flash drives or in RAM
   - Optimized for storing small to medium size key-values on fast storage --
     flash devices or in-memory
   - Scales linearly with number of CPUs so that it works well on ARM
     processors
 .
 This package contains libraries and header files for developing
 applications that use librocksdb .

Package: librocksdb9.2
Section: libs
Architecture: amd64 arm64 armel armhf loong64 ppc64el mips mipsel mips64el s390x i386 riscv64
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: persistent Key-Value Store for Flash and RAM Storage
 C++ library providing an embedded key-value store, where keys and values are
 arbitrary byte streams. It was developed at Facebook based on LevelDB and
 provides backwards-compatible support for LevelDB APIs.
 .
 RocksDB is optimized for Flash with extremely low latencies. RocksDB uses a
 Log Structured Database Engine for storage, written entirely in C++.
 .
 RocksDB features highly flexible configuration settings that may be tuned to
 run on a variety of production environments, including pure memory, Flash,
 hard disks or HDFS. It supports various compression algorithms and good tools
 for production support and debugging.
 .
 Features:
   - Designed for application servers wanting to store up to a few terabytes
     of data on locally attached Flash drives or in RAM
   - Optimized for storing small to medium size key-values on fast storage --
     flash devices or in-memory
   - Scales linearly with number of CPUs so that it works well on ARM
     processors

Package: rocksdb-tools
Architecture: amd64 arm64 armel armhf loong64 ppc64el mips mipsel mips64el s390x i386 riscv64
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: persistent Key-Value Store for Flash and RAM Storage (tools)
 C++ library providing an embedded key-value store, where keys and values are
 arbitrary byte streams. It was developed at Facebook based on LevelDB and
 provides backwards-compatible support for LevelDB APIs.
 .
 RocksDB is optimized for Flash with extremely low latencies. RocksDB uses a
 Log Structured Database Engine for storage, written entirely in C++.
 .
 RocksDB features highly flexible configuration settings that may be tuned to
 run on a variety of production environments, including pure memory, Flash,
 hard disks or HDFS. It supports various compression algorithms and good tools
 for production support and debugging.
 .
 Features:
   - Designed for application servers wanting to store up to a few terabytes
     of data on locally attached Flash drives or in RAM
   - Optimized for storing small to medium size key-values on fast storage --
     flash devices or in-memory
   - Scales linearly with number of CPUs so that it works well on ARM
     processors
 .
 This package contains administration and data access tools.

## rocksdb 9.3.1

=== Makefile ===
# Copyright (c) 2011 The LevelDB Authors. All rights reserved.
# Use of this source code is governed by a BSD-style license that can be
# found in the LICENSE file. See the AUTHORS file for names of contributors.

# Inherit some settings from environment variables, if available

#-----------------------------------------------

BASH_EXISTS := $(shell which bash)
SHELL := $(shell which bash)
include common.mk

CLEAN_FILES = # deliberately empty, so we can append below.
CFLAGS += ${EXTRA_CFLAGS}
CXXFLAGS += ${EXTRA_CXXFLAGS}
LDFLAGS += $(EXTRA_LDFLAGS)
MACHINE ?= $(shell uname -m)
ARFLAGS = ${EXTRA_ARFLAGS} rs
STRIPFLAGS = -S -x

# Transform parallel LOG output into something more readable.
perl_command = perl -n \
  -e '@a=split("\t",$$_,-1); $$t=$$a[8];'				\
  -e '$$t =~ /.*if\s\[\[\s"(.*?\.[\w\/]+)/ and $$t=$$1;'		\
  -e '$$t =~ s,^\./,,;'							\
  -e '$$t =~ s, >.*,,; chomp $$t;'					\
  -e '$$t =~ /.*--gtest_filter=(.*?\.[\w\/]+)/ and $$t=$$1;'		\
  -e 'printf "%7.3f %s %s\n", $$a[3], $$a[6] == 0 ? "PASS" : "FAIL", $$t'
quoted_perl_command = $(subst ','\'',$(perl_command))

# DEBUG_LEVEL can have three values:
# * DEBUG_LEVEL=2; this is the ultimate debug mode. It will compile rocksdb
# without any optimizations. To compile with level 2, issue `make dbg`
# * DEBUG_LEVEL=1; debug level 1 enables all assertions and debug code, but
# compiles rocksdb with -O2 optimizations. this is the default debug level.
# `make all` or `make <binary_target>` compile RocksDB with debug level 1.
# We use this debug level when developing RocksDB.
# * DEBUG_LEVEL=0; this is the debug level we use for release. If you're
# running rocksdb in production you most definitely want to compile RocksDB
# with debug level 0. To compile with level 0, run `make shared_lib`,
# `make install-shared`, `make static_lib`, `make install-static` or
# `make install`

# Set the default DEBUG_LEVEL to 1
DEBUG_LEVEL?=1

# OBJ_DIR is where the object files reside.  Default to the current directory
OBJ_DIR?=.

# Check the MAKECMDGOALS to set the DEBUG_LEVEL and LIB_MODE appropriately

ifneq ($(filter clean release install, $(MAKECMDGOALS)),)
	DEBUG_LEVEL=0
endif
ifneq ($(filter dbg, $(MAKECMDGOALS)),)
	DEBUG_LEVEL=2
else ifneq ($(filter shared_lib install-shared, $(MAKECMDGOALS)),)
	DEBUG_LEVEL=0
	LIB_MODE=shared
else ifneq ($(filter static_lib install-static, $(MAKECMDGOALS)),)
	DEBUG_LEVEL=0
	LIB_MODE=static
else ifneq ($(filter jtest rocksdbjava%, $(MAKECMDGOALS)),)
	OBJ_DIR=jl
	LIB_MODE=shared
	ifneq ($(findstring rocksdbjavastatic, $(MAKECMDGOALS)),)
		OBJ_DIR=jls
		ifneq ($(DEBUG_LEVEL),2)
			DEBUG_LEVEL=0
		endif
		ifeq ($(MAKECMDGOALS),rocksdbjavastaticpublish)
			DEBUG_LEVEL=0
		endif
	endif
endif

# LIB_MODE says whether or not to use/build "shared" or "static" libraries.
# Mode "static" means to link against static libraries (.a)
# Mode "shared" means to link against shared libraries (.so, .sl, .dylib, etc)
#
ifeq ($(DEBUG_LEVEL), 0)
# For optimized, set the default LIB_MODE to static for code size/efficiency
	LIB_MODE?=static
else
# For debug, set the default LIB_MODE to shared for efficient `make check` etc.
	LIB_MODE?=shared
endif

$(info $$DEBUG_LEVEL is $(DEBUG_LEVEL), $$LIB_MODE is $(LIB_MODE))

# Detect what platform we're building on.
# Export some common variables that might have been passed as Make variables
# instead of environment variables.
dummy := $(shell (export ROCKSDB_ROOT="$(CURDIR)"; \
                  export CXXFLAGS="$(EXTRA_CXXFLAGS)"; \
                  export LDFLAGS="$(EXTRA_LDFLAGS)"; \
                  export COMPILE_WITH_ASAN="$(COMPILE_WITH_ASAN)"; \
                  export COMPILE_WITH_TSAN="$(COMPILE_WITH_TSAN)"; \
                  export COMPILE_WITH_UBSAN="$(COMPILE_WITH_UBSAN)"; \
                  export PORTABLE="$(PORTABLE)"; \
                  export ROCKSDB_NO_FBCODE="$(ROCKSDB_NO_FBCODE)"; \
                  export USE_CLANG="$(USE_CLANG)"; \
                  export LIB_MODE="$(LIB_MODE)"; \
		  export ROCKSDB_CXX_STANDARD="$(ROCKSDB_CXX_STANDARD)"; \
		  export USE_FOLLY="$(USE_FOLLY)"; \
                  "$(CURDIR)/build_tools/build_detect_platform" "$(CURDIR)/make_config.mk"))
# this file is generated by the previous line to set build flags and sources
include make_config.mk

# Figure out optimize level.
ifneq ($(DEBUG_LEVEL), 2)
	OPTIMIZE_LEVEL ?= -O2
endif
# `OPTIMIZE_LEVEL` is empty when the user does not set it and `DEBUG_LEVEL=2`.
# In that case, the compiler default (`-O0` for gcc and clang) will be used.
OPT += $(OPTIMIZE_LEVEL)

# compile with -O2 if debug level is not 2
ifneq ($(DEBUG_LEVEL), 2)
OPT += -fno-omit-frame-pointer
# Skip for archs that don't support -momit-leaf-frame-pointer
ifeq (,$(shell $(CXX) -fsyntax-only -momit-leaf-frame-pointer -xc /dev/null 2>&1))
OPT += -momit-leaf-frame-pointer
endif
endif

ifeq (,$(shell $(CXX) -fsyntax-only -maltivec -xc /dev/null 2>&1))
CXXFLAGS += -DHAS_ALTIVEC
CFLAGS += -DHAS_ALTIVEC
HAS_ALTIVEC=1
endif

ifeq (,$(shell $(CXX) -fsyntax-only -mcpu=power8 -xc /dev/null 2>&1))
CXXFLAGS += -DHAVE_POWER8
CFLAGS +=  -DHAVE_POWER8
HAVE_POWER8=1
endif

# if we're compiling for shared libraries, add the shared flags
ifeq ($(LIB_MODE),shared)
CXXFLAGS += $(PLATFORM_SHARED_CFLAGS) -DROCKSDB_DLL
CFLAGS +=  $(PLATFORM_SHARED_CFLAGS) -DROCKSDB_DLL
endif

GIT_COMMAND ?= git
ifeq ($(USE_COROUTINES), 1)
	USE_FOLLY = 1
	# glog/logging.h requires HAVE_CXX11_ATOMIC
	OPT += -DUSE_COROUTINES -DHAVE_CXX11_ATOMIC
	ROCKSDB_CXX_STANDARD = c++2a
	USE_RTTI = 1
ifneq ($(USE_CLANG), 1)
	ROCKSDB_CXX_STANDARD = c++20
	PLATFORM_CXXFLAGS += -fcoroutines
endif
endif

# if we're compiling for release, compile without debug code (-DNDEBUG)
ifeq ($(DEBUG_LEVEL),0)
OPT += -DNDEBUG

ifneq ($(USE_RTTI), 1)
	CXXFLAGS += -fno-rtti
else
	CXXFLAGS += -DROCKSDB_USE_RTTI
endif
else
ifneq ($(USE_RTTI), 0)
	CXXFLAGS += -DROCKSDB_USE_RTTI
else
	CXXFLAGS += -fno-rtti
endif

ifdef ASSERT_STATUS_CHECKED
# For ASC, turn off constructor elision, preventing the case where a constructor returned
# by a method may pass the ASC check if the status is checked in the inner method.  Forcing
# the copy constructor to be invoked disables the optimization and will cause the calling method
# to check the status in order to prevent an error from being raised.
PLATFORM_CXXFLAGS += -fno-elide-constructors
ifeq ($(filter -DROCKSDB_ASSERT_STATUS_CHECKED,$(OPT)),)
	OPT += -DROCKSDB_ASSERT_STATUS_CHECKED
endif
endif

$(warning Warning: Compiling in debug mode. Don't use the resulting binary in production)
endif

# `USE_LTO=1` enables link-time optimizations. Among other things, this enables
# more devirtualization opportunities and inlining across translation units.
# This can save significant overhead introduced by RocksDB's pluggable
# interfaces/internal abstractions, like in the iterator hierarchy. It works
# better when combined with profile-guided optimizations (not currently
# supported natively in Makefile).
ifeq ($(USE_LTO), 1)
	CXXFLAGS += -flto
	LDFLAGS += -flto -fuse-linker-plugin
endif

# `COERCE_CONTEXT_SWITCH=1` will inject spurious wakeup and
# random length of sleep or context switch at critical
# points (e.g, before acquring db mutex) in RocksDB.
# In this way, it coerces as many excution orders as possible in the hope of
# exposing the problematic excution order
COERCE_CONTEXT_SWITCH ?= 0
ifeq ($(COERCE_CONTEXT_SWITCH), 1)
OPT += -DCOERCE_CONTEXT_SWITCH
endif

#-----------------------------------------------
include src.mk

AM_DEFAULT_VERBOSITY ?= 0

AM_V_GEN = $(am__v_GEN_$(V))
am__v_GEN_ = $(am__v_GEN_$(AM_DEFAULT_VERBOSITY))
am__v_GEN_0 = @echo "  GEN     " $@;
am__v_GEN_1 =
AM_V_at = $(am__v_at_$(V))
am__v_at_ = $(am__v_at_$(AM_DEFAULT_VERBOSITY))
am__v_at_0 = @
am__v_at_1 =

AM_V_CC = $(am__v_CC_$(V))
am__v_CC_ = $(am__v_CC_$(AM_DEFAULT_VERBOSITY))
am__v_CC_0 = @echo "  CC      " $@;
am__v_CC_1 =

AM_V_CCLD = $(am__v_CCLD_$(V))
am__v_CCLD_ = $(am__v_CCLD_$(AM_DEFAULT_VERBOSITY))
ifneq ($(SKIP_LINK), 1)
am__v_CCLD_0 = @echo "  CCLD    " $@;
am__v_CCLD_1 =
else
am__v_CCLD_0 = @echo "  !CCLD   " $@; true skip
am__v_CCLD_1 = true skip
endif
AM_V_AR = $(am__v_AR_$(V))
am__v_AR_ = $(am__v_AR_$(AM_DEFAULT_VERBOSITY))
am__v_AR_0 = @echo "  AR      " $@;
am__v_AR_1 =

AM_LINK = $(AM_V_CCLD)$(CXX) -L. $(patsubst lib%.a, -l%, $(patsubst lib%.$(PLATFORM_SHARED_EXT), -l%, $^)) $(EXEC_LDFLAGS) -o $@ $(LDFLAGS) $(COVERAGEFLAGS)
AM_SHARE = $(AM_V_CCLD) $(CXX) $(PLATFORM_SHARED_LDFLAGS)$@ -L. $(patsubst lib%.$(PLATFORM_SHARED_EXT), -l%, $^) $(EXEC_LDFLAGS) $(LDFLAGS) -o $@

ROCKSDB_PLUGIN_MKS = $(foreach plugin, $(ROCKSDB_PLUGINS), plugin/$(plugin)/*.mk)
include $(ROCKSDB_PLUGIN_MKS)
ROCKSDB_PLUGIN_PROTO =ROCKSDB_NAMESPACE::ObjectLibrary\&, const std::string\&
ROCKSDB_PLUGIN_SOURCES = $(foreach p, $(ROCKSDB_PLUGINS), $(foreach source, $($(p)_SOURCES), plugin/$(p)/$(source)))
ROCKSDB_PLUGIN_HEADERS = $(foreach p, $(ROCKSDB_PLUGINS), $(foreach header, $($(p)_HEADERS), plugin/$(p)/$(header)))
ROCKSDB_PLUGIN_LIBS = $(foreach p, $(ROCKSDB_PLUGINS), $(foreach lib, $($(p)_LIBS), -l$(lib)))
ROCKSDB_PLUGIN_W_FUNCS = $(foreach p, $(ROCKSDB_PLUGINS), $(if $($(p)_FUNC), $(p)))
ROCKSDB_PLUGIN_EXTERNS = $(foreach p, $(ROCKSDB_PLUGIN_W_FUNCS), int $($(p)_FUNC)($(ROCKSDB_PLUGIN_PROTO));)
ROCKSDB_PLUGIN_BUILTINS = $(foreach p, $(ROCKSDB_PLUGIN_W_FUNCS), {\"$(p)\"\, $($(p)_FUNC)}\,)
ROCKSDB_PLUGIN_LDFLAGS = $(foreach plugin, $(ROCKSDB_PLUGINS), $($(plugin)_LDFLAGS))
ROCKSDB_PLUGIN_PKGCONFIG_REQUIRES = $(foreach plugin, $(ROCKSDB_PLUGINS), $($(plugin)_PKGCONFIG_REQUIRES))
ROCKSDB_PLUGIN_TESTS = $(foreach p, $(ROCKSDB_PLUGINS), $(foreach test, $($(p)_TESTS), plugin/$(p)/$(test)))

CXXFLAGS += $(foreach plugin, $(ROCKSDB_PLUGINS), $($(plugin)_CXXFLAGS))
PLATFORM_LDFLAGS += $(ROCKSDB_PLUGIN_LDFLAGS)

# Patch up the link flags for JNI from the plugins
JAVA_LDFLAGS += $(ROCKSDB_PLUGIN_LDFLAGS)
JAVA_STATIC_LDFLAGS += $(ROCKSDB_PLUGIN_LDFLAGS)

# Patch up the list of java native sources with files from the plugins
ROCKSDB_PLUGIN_JNI_NATIVE_SOURCES = $(foreach plugin, $(ROCKSDB_PLUGINS), $(foreach source, $($(plugin)_JNI_NATIVE_SOURCES), plugin/$(plugin)/$(source)))
ALL_JNI_NATIVE_SOURCES = $(JNI_NATIVE_SOURCES) $(ROCKSDB_PLUGIN_JNI_NATIVE_SOURCES)
ROCKSDB_PLUGIN_JNI_CXX_INCLUDEFLAGS = $(foreach plugin, $(ROCKSDB_PLUGINS), -I./plugin/$(plugin))

ifneq ($(strip $(ROCKSDB_PLUGIN_PKGCONFIG_REQUIRES)),)
LDFLAGS := $(LDFLAGS) $(shell pkg-config --libs $(ROCKSDB_PLUGIN_PKGCONFIG_REQUIRES))
ifneq ($(.SHELLSTATUS),0)
$(error pkg-config failed)
endif
CXXFLAGS := $(CXXFLAGS) $(shell pkg-config --cflags $(ROCKSDB_PLUGIN_PKGCONFIG_REQUIRES))
ifneq ($(.SHELLSTATUS),0)
$(error pkg-config failed)
endif
endif

CXXFLAGS += $(ARCHFLAG)

ifeq (,$(shell $(CXX) -fsyntax-only -march=armv8-a+crc+crypto -xc /dev/null 2>&1))
ifneq ($(PLATFORM),OS_MACOSX)
CXXFLAGS += -march=armv8-a+crc+crypto
CFLAGS += -march=armv8-a+crc+crypto
ARMCRC_SOURCE=1
endif
endif

export JAVAC_ARGS
CLEAN_FILES += make_config.mk rocksdb.pc

ifeq ($(V), 1)
$(info $(shell uname -a))
$(info $(shell $(CC) --version))
$(info $(shell $(CXX) --version))
endif

missing_make_config_paths := $(shell				\
	grep "\./\S*\|/\S*" -o $(CURDIR)/make_config.mk | 	\
	while read path;					\
		do [ -e $$path ] || echo $$path; 		\
	done | sort | uniq | grep -v "/DOES/NOT/EXIST")

$(foreach path, $(missing_make_config_paths), \
	$(warning Warning: $(path) does not exist))

ifeq ($(PLATFORM), OS_AIX)
# no debug info
else ifneq ($(PLATFORM), IOS)
CFLAGS += -g
CXXFLAGS += -g
else
# no debug info for IOS, that will make our library big
OPT += -DNDEBUG
endif

ifeq ($(PLATFORM), OS_AIX)
ARFLAGS = -X64 rs
STRIPFLAGS = -X64 -x
endif

ifeq ($(PLATFORM), OS_SOLARIS)
	PLATFORM_CXXFLAGS += -D _GLIBCXX_USE_C99
endif

ifeq ($(LIB_MODE),shared)
# So that binaries are executable from build location, in addition to install location
EXEC_LDFLAGS += -Wl,-rpath -Wl,'$$ORIGIN'
endif

ifeq ($(PLATFORM), OS_MACOSX)
ifeq ($(ARCHFLAG), -arch arm64)
ifneq ($(MACHINE), arm64)

=== debian/changelog ===
rocksdb (9.3.1-1) unstable; urgency=medium

  * New major upstream release.
  * Library transition from librocksdb9.2 to librocksdb9.3.

 -- Otto Kekäläinen <otto@debian.org>  Mon, 01 Jul 2024 16:27:03 -0700

=== debian/control ===
--- 
+++ 
@@ -7,11 +7,13 @@
 Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://rocksdb.org/
+Vcs-Browser: https://salsa.debian.org/debian/rocksdb
+Vcs-Git: https://salsa.debian.org/debian/rocksdb.git
 
 Package: librocksdb-dev
 Section: libdevel
 Architecture: amd64 arm64 armel armhf loong64 ppc64el mips mipsel mips64el s390x i386 riscv64
-Depends: ${misc:Depends}, librocksdb9.2 (= ${binary:Version}), libgflags-dev,
+Depends: ${misc:Depends}, librocksdb9.3 (= ${binary:Version}), libgflags-dev,
  libsnappy-dev, libbz2-dev, zlib1g-dev, liblz4-dev, libzstd-dev
 Description: persistent Key-Value Store for Flash and RAM Storage (development)
  C++ library providing an embedded key-value store, where keys and values are
@@ -37,7 +39,7 @@
  This package contains libraries and header files for developing
  applications that use librocksdb .
 
-Package: librocksdb9.2
+Package: librocksdb9.3
 Section: libs
 Architecture: amd64 arm64 armel armhf loong64 ppc64el mips mipsel mips64el s390x i386 riscv64
 Depends: ${misc:Depends}, ${shlibs:Depends}

## rocksdb 9.8.4

=== CMakeLists.txt ===
# Prerequisites for Windows:
#     This cmake build is for Windows 64-bit only.
#
# Prerequisites:
#     You must have at least Visual Studio 2019. Start the Developer Command Prompt window that is a part of Visual Studio installation.
#     Run the build commands from within the Developer Command Prompt window to have paths to the compiler and runtime libraries set.
#     You must have git.exe in your %PATH% environment variable.
#
# To build Rocksdb for Windows is as easy as 1-2-3-4-5:
#
# 1. Update paths to third-party libraries in thirdparty.inc file
# 2. Create a new directory for build artifacts
#        mkdir build
#        cd build
# 3. Run cmake to generate project files for Windows, add more options to enable required third-party libraries.
#    See thirdparty.inc for more information.
#        sample command: cmake -G "Visual Studio 16 2019" -DCMAKE_BUILD_TYPE=Release -DWITH_GFLAGS=1 -DWITH_SNAPPY=1 -DWITH_JEMALLOC=1 -DWITH_JNI=1 ..
# 4. Then build the project in debug mode (you may want to add /m[:<N>] flag to run msbuild in <N> parallel threads
#                                          or simply /m to use all avail cores)
#        msbuild rocksdb.sln
#
#        rocksdb.sln build features exclusions of test only code in Release. If you build ALL_BUILD then everything
#        will be attempted but test only code does not build in Release mode.
#
# 5. And release mode (/m[:<N>] is also supported)
#        msbuild rocksdb.sln /p:Configuration=Release
#
# Linux:
#
# 1. Install a recent toolchain if you're on a older distro. C++17 required (GCC >= 7, Clang >= 5)
# 2. mkdir build; cd build
# 3. cmake ..
# 4. make -j

cmake_minimum_required(VERSION 3.12)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake/modules/")
include(ReadVersion)
include(GoogleTest)
get_rocksdb_version(rocksdb_VERSION)
project(rocksdb
  VERSION ${rocksdb_VERSION}
  DESCRIPTION "An embeddable persistent key-value store for fast storage"
  HOMEPAGE_URL https://rocksdb.org/
  LANGUAGES CXX C ASM)

if(APPLE)
  # On macOS Cmake, when cross-compiling, sometimes CMAKE_SYSTEM_PROCESSOR wrongfully stays
  # the same as CMAKE_HOST_SYSTEM_PROCESSOR regardless the target CPU.
  # The manual call to  set(CMAKE_SYSTEM_PROCESSOR) has to be set after the project() call.
  # because project() might reset CMAKE_SYSTEM_PROCESSOR back to the value of CMAKE_HOST_SYSTEM_PROCESSOR.
  # Check if CMAKE_SYSTEM_PROCESSOR is not equal to CMAKE_OSX_ARCHITECTURES
  if(NOT CMAKE_OSX_ARCHITECTURES STREQUAL "")
    if(NOT CMAKE_SYSTEM_PROCESSOR STREQUAL CMAKE_OSX_ARCHITECTURES)
      # Split CMAKE_OSX_ARCHITECTURES into a list
      string(REPLACE ";" " " ARCH_LIST ${CMAKE_OSX_ARCHITECTURES})
      separate_arguments(ARCH_LIST UNIX_COMMAND ${ARCH_LIST})
      # Count the number of architectures
      list(LENGTH ARCH_LIST ARCH_COUNT)
      # Ensure that exactly one architecture is specified
      if(NOT ARCH_COUNT EQUAL 1)
          message(FATAL_ERROR "CMAKE_OSX_ARCHITECTURES must have exactly one value. Current value: ${CMAKE_OSX_ARCHITECTURES}")
      endif()
      set(CMAKE_SYSTEM_PROCESSOR ${CMAKE_OSX_ARCHITECTURES})
      message(STATUS "CMAKE_SYSTEM_PROCESSOR is manually set to ${CMAKE_SYSTEM_PROCESSOR}")
    endif()
  endif()
endif()

if(POLICY CMP0042)
  cmake_policy(SET CMP0042 NEW)
endif()

if(NOT CMAKE_BUILD_TYPE)
  if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
    set(default_build_type "Debug")
  else()
    set(default_build_type "RelWithDebInfo")
  endif()
  set(CMAKE_BUILD_TYPE "${default_build_type}" CACHE STRING
    "Default BUILD_TYPE is ${default_build_type}" FORCE)
endif()

find_program(CCACHE_FOUND ccache)
if(CCACHE_FOUND)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
endif(CCACHE_FOUND)

option(WITH_JEMALLOC "build with JeMalloc" OFF)
option(WITH_LIBURING "build with liburing" ON)
option(WITH_SNAPPY "build with SNAPPY" OFF)
option(WITH_LZ4 "build with lz4" OFF)
option(WITH_ZLIB "build with zlib" OFF)
option(WITH_ZSTD "build with zstd" OFF)
option(WITH_WINDOWS_UTF8_FILENAMES "use UTF8 as characterset for opening files, regardles of the system code page" OFF)
if (WITH_WINDOWS_UTF8_FILENAMES)
  add_definitions(-DROCKSDB_WINDOWS_UTF8_FILENAMES)
endif()
option(ROCKSDB_BUILD_SHARED "Build shared versions of the RocksDB libraries" ON)

if( NOT DEFINED CMAKE_CXX_STANDARD )
  set(CMAKE_CXX_STANDARD 17)
endif()

include(CMakeDependentOption)

if(MSVC)
  option(WITH_GFLAGS "build with GFlags" OFF)
  option(WITH_XPRESS "build with windows built in compression" OFF)
  option(ROCKSDB_SKIP_THIRDPARTY "skip thirdparty.inc" OFF)

  if(NOT ROCKSDB_SKIP_THIRDPARTY)
    include(${CMAKE_CURRENT_SOURCE_DIR}/thirdparty.inc)
  endif()
else()
  if(CMAKE_SYSTEM_NAME MATCHES "FreeBSD" AND NOT CMAKE_SYSTEM_NAME MATCHES "kFreeBSD")
    # FreeBSD has jemalloc as default malloc
    # but it does not have all the jemalloc files in include/...
    set(WITH_JEMALLOC ON)
  else()
    if(WITH_JEMALLOC)
      find_package(JeMalloc REQUIRED)
      add_definitions(-DROCKSDB_JEMALLOC -DJEMALLOC_NO_DEMANGLE)
      list(APPEND THIRDPARTY_LIBS JeMalloc::JeMalloc)
    endif()
  endif()

  if(MINGW)
    option(WITH_GFLAGS "build with GFlags" OFF)
  else()
    option(WITH_GFLAGS "build with GFlags" ON)
  endif()
  set(GFLAGS_LIB)
  if(WITH_GFLAGS)
    # Config with namespace available since gflags 2.2.2
    option(GFLAGS_USE_TARGET_NAMESPACE "Use gflags import target with namespace." ON)
    find_package(gflags CONFIG)
    if(gflags_FOUND)
      if(TARGET ${GFLAGS_TARGET})
        # Config with GFLAGS_TARGET available since gflags 2.2.0
        set(GFLAGS_LIB ${GFLAGS_TARGET})
      else()
        # Config with GFLAGS_LIBRARIES available since gflags 2.1.0
        set(GFLAGS_LIB ${gflags_LIBRARIES})
      endif()
    else()
      find_package(gflags REQUIRED)
      set(GFLAGS_LIB gflags::gflags)
    endif()
    include_directories(${GFLAGS_INCLUDE_DIR})
    list(APPEND THIRDPARTY_LIBS ${GFLAGS_LIB})
    add_definitions(-DGFLAGS=1)
  endif()

  if(WITH_SNAPPY)
    find_package(Snappy CONFIG)
    if(NOT Snappy_FOUND)
      find_package(Snappy REQUIRED)
    endif()
    add_definitions(-DSNAPPY)
    list(APPEND THIRDPARTY_LIBS Snappy::snappy)
  endif()

  if(WITH_ZLIB)
    find_package(ZLIB REQUIRED)
    add_definitions(-DZLIB)
    list(APPEND THIRDPARTY_LIBS ZLIB::ZLIB)
  endif()

  option(WITH_BZ2 "build with bzip2" OFF)
  if(WITH_BZ2)
    find_package(BZip2 REQUIRED)
    add_definitions(-DBZIP2)
    if(BZIP2_INCLUDE_DIRS)
      include_directories(${BZIP2_INCLUDE_DIRS})
    else()
      include_directories(${BZIP2_INCLUDE_DIR})
    endif()
    list(APPEND THIRDPARTY_LIBS ${BZIP2_LIBRARIES})
  endif()

  if(WITH_LZ4)
    find_package(lz4 REQUIRED)
    add_definitions(-DLZ4)
    list(APPEND THIRDPARTY_LIBS lz4::lz4)
  endif()

  if(WITH_ZSTD)
    find_package(zstd REQUIRED)
    add_definitions(-DZSTD)
    include_directories(${ZSTD_INCLUDE_DIRS})
    list(APPEND THIRDPARTY_LIBS zstd::zstd)
  endif()
endif()

option(WITH_MD_LIBRARY "build with MD" ON)
if(WIN32 AND MSVC)
  if(WITH_MD_LIBRARY)
    set(RUNTIME_LIBRARY "MD")
  else()
    set(RUNTIME_LIBRARY "MT")
  endif()
endif()

if(MSVC)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /Zi /nologo /EHsc /GS /Gd /GR /GF /fp:precise /Zc:wchar_t /Zc:forScope /errorReport:queue")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /FC /d2Zi+ /W4 /wd4127 /wd4996 /wd4100 /wd4324")
else()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -W -Wextra -Wall -pthread")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wsign-compare -Wshadow -Wno-unused-parameter -Wno-unused-variable -Woverloaded-virtual -Wnon-virtual-dtor -Wno-missing-field-initializers -Wno-strict-aliasing -Wno-invalid-offsetof")
  if(CMAKE_SYSTEM_PROCESSOR MATCHES "x86_64")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wstrict-prototypes")
  endif()
  if(MINGW)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-format")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wa,-mbig-obj")
    add_definitions(-D_POSIX_C_SOURCE=1)
  endif()
  if(NOT CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-omit-frame-pointer")
    include(CheckCXXCompilerFlag)
    CHECK_CXX_COMPILER_FLAG("-momit-leaf-frame-pointer" HAVE_OMIT_LEAF_FRAME_POINTER)
    if(HAVE_OMIT_LEAF_FRAME_POINTER)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -momit-leaf-frame-pointer")
    endif()
  endif()
endif()

include(CheckCCompilerFlag)
if(CMAKE_SYSTEM_PROCESSOR MATCHES "^(powerpc|ppc)64")
  CHECK_C_COMPILER_FLAG("-mcpu=power9" HAS_POWER9)
  if(HAS_POWER9)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mcpu=power9 -mtune=power9")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mcpu=power9 -mtune=power9")
  else()
    CHECK_C_COMPILER_FLAG("-mcpu=power8" HAS_POWER8)
    if(HAS_POWER8)
      set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -mcpu=power8 -mtune=power8")
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mcpu=power8 -mtune=power8")
    endif(HAS_POWER8)
  endif(HAS_POWER9)
  CHECK_C_COMPILER_FLAG("-maltivec" HAS_ALTIVEC)
  if(HAS_ALTIVEC)
    message(STATUS " HAS_ALTIVEC yes")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -maltivec")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -maltivec")
  endif(HAS_ALTIVEC)
endif(CMAKE_SYSTEM_PROCESSOR MATCHES "^(powerpc|ppc)64")

if(CMAKE_SYSTEM_PROCESSOR MATCHES "arm64|aarch64|AARCH64")
        CHECK_C_COMPILER_FLAG("-march=armv8-a+crc+crypto" HAS_ARMV8_CRC)
  if(HAS_ARMV8_CRC)
    message(STATUS " HAS_ARMV8_CRC yes")
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -march=armv8-a+crc+crypto -Wno-unused-function")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=armv8-a+crc+crypto -Wno-unused-function")
  endif(HAS_ARMV8_CRC)
endif(CMAKE_SYSTEM_PROCESSOR MATCHES "arm64|aarch64|AARCH64")

if(CMAKE_SYSTEM_PROCESSOR MATCHES "s390x")
  CHECK_C_COMPILER_FLAG("-march=native" HAS_S390X_MARCH_NATIVE)
  if(HAS_S390X_MARCH_NATIVE)
    message(STATUS " HAS_S390X_MARCH_NATIVE yes")
  endif(HAS_S390X_MARCH_NATIVE)
endif(CMAKE_SYSTEM_PROCESSOR MATCHES "s390x")

if(CMAKE_SYSTEM_PROCESSOR MATCHES "loongarch64")
  CHECK_C_COMPILER_FLAG("-march=loongarch64" HAS_LOONGARCH64)
  if(HAS_LOONGARCH64)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -march=loongarch64 -mtune=loongarch64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=loongarch64 -mtune=loongarch64")
  endif(HAS_LOONGARCH64)
endif(CMAKE_SYSTEM_PROCESSOR MATCHES "loongarch64")

set(PORTABLE 0 CACHE STRING "Minimum CPU arch to support, or 0 = current CPU, 1 = baseline CPU")
if(PORTABLE MATCHES "1|ON|YES|TRUE|Y")
  # Usually nothing to do; compiler default is typically the most general
  if(NOT MSVC)
    if(CMAKE_SYSTEM_PROCESSOR MATCHES "^s390x")
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=z196")
    endif()
    if(CMAKE_SYSTEM_PROCESSOR MATCHES "^loongarch64")
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=loongarch64")
    endif()
  endif()
elseif(PORTABLE MATCHES "0|OFF|NO|FALSE|N")
  if(MSVC)
    # NOTE: No auto-detection of current CPU, but instead assume some useful
    # level of optimization is supported
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /arch:AVX2")
  else()
    # Require instruction set from current CPU (with some legacy or opt-out
    # exceptions)
    if(CMAKE_SYSTEM_PROCESSOR MATCHES "^s390x" AND NOT HAS_S390X_MARCH_NATIVE)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=z196")
    elseif(NOT CMAKE_SYSTEM_PROCESSOR MATCHES "^(powerpc|ppc)64" AND NOT HAS_ARMV8_CRC)
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
    endif()
  endif()
else()
  # Name of a CPU arch spec or feature set to require
  if(MSVC)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /arch:${PORTABLE}")
  else()
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=${PORTABLE}")
  endif()
endif()

include(CheckCXXSourceCompiles)
set(OLD_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
if(NOT MSVC)
  set(CMAKE_REQUIRED_FLAGS "-msse4.2 -mpclmul")
endif()

# Check if -latomic is required or not
if (NOT MSVC)
  set(CMAKE_REQUIRED_FLAGS "--std=c++17")

=== debian/changelog ===
rocksdb (9.8.4-1) unstable; urgency=medium

  * New upstream release 9.8.4 with plenty of changes, see
    - https://github.com/facebook/rocksdb/releases/tag/v9.8.4
    - https://github.com/facebook/rocksdb/releases/tag/v9.7.4
    - https://github.com/facebook/rocksdb/releases/tag/v9.6.1
    - https://github.com/facebook/rocksdb/releases/tag/v9.5.2
    - https://github.com/facebook/rocksdb/releases/tag/v9.4.0
  * Extend gbp.conf and write a README.source.md about package maintenance
    (Closes: #1070099)
  * Add myself as uploader and co-maintainer
  * Add upstream/metadata file
  * Library transition from librocksdb9.2 to librocksdb9.8

 -- Otto Kekäläinen <otto@debian.org>  Wed, 11 Dec 2024 22:40:21 -0800

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,18 @@
 Section: database
 Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
-Build-Depends: debhelper-compat (= 13), cmake, libgflags-dev, libsnappy-dev,
- libbz2-dev, zlib1g-dev, liblz4-dev, libzstd-dev
+Uploaders:
+ Laszlo Boszormenyi (GCS) <gcs@debian.org>,
+ Otto Kekäläinen <otto@debian.org>,
+Build-Depends:
+ cmake,
+ debhelper-compat (= 13),
+ libbz2-dev,
+ libgflags-dev,
+ liblz4-dev,
+ libsnappy-dev,
+ libzstd-dev,
+ zlib1g-dev,
 Standards-Version: 4.7.0
 Rules-Requires-Root: no
 Homepage: https://rocksdb.org/
@@ -12,9 +22,16 @@
 
 Package: librocksdb-dev
 Section: libdevel
-Architecture: amd64 arm64 armel armhf loong64 ppc64el mips mipsel mips64el s390x i386 riscv64
-Depends: ${misc:Depends}, librocksdb9.3 (= ${binary:Version}), libgflags-dev,
- libsnappy-dev, libbz2-dev, zlib1g-dev, liblz4-dev, libzstd-dev
+Architecture: amd64 arm64 armel armhf i386 loong64 mips mips64el mipsel ppc64el riscv64 s390x
+Depends:
+ libbz2-dev,
+ libgflags-dev,
+ liblz4-dev,
+ librocksdb9.8 (= ${binary:Version}),
+ libsnappy-dev,
+ libzstd-dev,
+ zlib1g-dev,
+ ${misc:Depends},
 Description: persistent Key-Value Store for Flash and RAM Storage (development)
  C++ library providing an embedded key-value store, where keys and values are
  arbitrary byte streams. It was developed at Facebook based on LevelDB and
@@ -39,10 +56,12 @@
  This package contains libraries and header files for developing
  applications that use librocksdb .
 
-Package: librocksdb9.3
+Package: librocksdb9.8
 Section: libs
-Architecture: amd64 arm64 armel armhf loong64 ppc64el mips mipsel mips64el s390x i386 riscv64
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Architecture: amd64 arm64 armel armhf i386 loong64 mips mips64el mipsel ppc64el riscv64 s390x
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: persistent Key-Value Store for Flash and RAM Storage
  C++ library providing an embedded key-value store, where keys and values are
  arbitrary byte streams. It was developed at Facebook based on LevelDB and
@@ -65,8 +84,10 @@
      processors
 
 Package: rocksdb-tools
-Architecture: amd64 arm64 armel armhf loong64 ppc64el mips mipsel mips64el s390x i386 riscv64
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Architecture: amd64 arm64 armel armhf i386 loong64 mips mips64el mipsel ppc64el riscv64 s390x
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
 Description: persistent Key-Value Store for Flash and RAM Storage (tools)
  C++ library providing an embedded key-value store, where keys and values are
  arbitrary byte streams. It was developed at Facebook based on LevelDB and

## rocksdb 9.10.0

=== Makefile ===
--- 
+++ 
@@ -103,6 +103,7 @@
                   export LIB_MODE="$(LIB_MODE)"; \
 		  export ROCKSDB_CXX_STANDARD="$(ROCKSDB_CXX_STANDARD)"; \
 		  export USE_FOLLY="$(USE_FOLLY)"; \
+		  export USE_FOLLY_LITE="$(USE_FOLLY_LITE)"; \
                   "$(CURDIR)/build_tools/build_detect_platform" "$(CURDIR)/make_config.mk"))
 # this file is generated by the previous line to set build flags and sources
 include make_config.mk
@@ -331,5 +332,3 @@
 endif
 
 ifeq ($(PLATFORM), OS_MACOSX)
-ifeq ($(ARCHFLAG), -arch arm64)
-ifneq ($(MACHINE), arm64)

=== microbench/CMakeLists.txt ===
find_package(benchmark REQUIRED)
find_package(Threads REQUIRED)

file(GLOB_RECURSE ALL_BENCH_CPP *.cc)
foreach(ONE_BENCH_CPP ${ALL_BENCH_CPP})
  get_filename_component(TARGET_NAME ${ONE_BENCH_CPP} NAME_WE)
  add_executable(${TARGET_NAME} ${ONE_BENCH_CPP})
  target_link_libraries(${TARGET_NAME} ${ROCKSDB_LIB} benchmark::benchmark
          ${CMAKE_THREAD_LIBS_INIT})
  # run benchmark like a test, if added, the benchmark tests could be run by `ctest -R Bench_`
  # add_test(Bench_${TARGET_NAME} ${TARGET_NAME})
  list(APPEND ALL_BENCH_TARGETS ${TARGET_NAME})
endforeach()
add_custom_target(microbench DEPENDS ${ALL_BENCH_TARGETS})
add_custom_target(run_microbench
        COMMAND for t in ${ALL_BENCH_TARGETS}\; do \.\/$$t \|\| exit 1\; done
        DEPENDS ${ALL_BENCH_TARGETS})

=== debian/changelog ===
rocksdb (9.10.0-1) unstable; urgency=medium

  * New upstream release 9.10.0, see details at
    - https://github.com/facebook/rocksdb/releases/tag/v9.10.0
    - https://github.com/facebook/rocksdb/releases/tag/v9.9.3
  * Main change between 9.8.4 and 9.10.0 seemingly is changes to how they do
    auto-triggered compaction of databases, including follow-up to a memory leak
    (https://github.com/facebook/rocksdb/pull/13106) which most likely fixes
    issue seen in Oxigraph (Closes: #1088523).
  * Bump library name to librocksdb9.10 so it matches latest RocksDB version.

 -- Otto Kekäläinen <otto@debian.org>  Fri, 24 Jan 2025 21:24:20 -0800

=== debian/control ===
--- 
+++ 
@@ -27,7 +27,7 @@
  libbz2-dev,
  libgflags-dev,
  liblz4-dev,
- librocksdb9.8 (= ${binary:Version}),
+ librocksdb9.10 (= ${binary:Version}),
  libsnappy-dev,
  libzstd-dev,
  zlib1g-dev,
@@ -56,7 +56,7 @@
  This package contains libraries and header files for developing
  applications that use librocksdb .
 
-Package: librocksdb9.8
+Package: librocksdb9.10
 Section: libs
 Architecture: amd64 arm64 armel armhf i386 loong64 mips mips64el mipsel ppc64el riscv64 s390x
 Depends:

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

ifneq ($(filter $(DEB_HOST_ARCH),armel mips mipsel riscv64),)
	export PLATFORM_LDFLAGS=-latomic
endif

ifeq ($(DEB_HOST_ARCH),armel)
	export DEB_CFLAGS_MAINT_APPEND= -mfloat-abi=softfp
	export DEB_CXXFLAGS_MAINT_APPEND= -mfloat-abi=softfp
endif

ifeq ($(DEB_HOST_ARCH),mipsel)
	export DEB_LDFLAGS_MAINT_APPEND= -latomic
endif

# make build verbose
export AM_DEFAULT_VERBOSITY=1

override_dh_auto_configure:
	dh_auto_configure -O--buildsystem=cmake \
		 -- \
		 -DWITH_BZ2=ON \
		 -DWITH_LZ4=ON \
		 -DWITH_ZLIB=ON \
		 -DWITH_ZSTD=ON \
		 -DWITH_SNAPPY=ON \
		 -DROCKSDB_BUILD_SHARED=ON \
		 -DWITH_BENCHMARK_TOOLS=ON \
		 -DWITH_CORE_TOOLS=ON \
		 -DWITH_TOOLS=ON \
		 -DWITH_TESTS=ON \
		 -DPORTABLE=1 \
		 -DFAIL_ON_WARNINGS=OFF

override_dh_auto_test:
	echo Test is no-op as running for hours on a normal PC

override_dh_auto_install:
	dh_auto_install -O--buildsystem=cmake --destdir=$(CURDIR)/debian/tmp/

override_dh_missing:
	dh_missing --list-missing

%:
	dh $@ --buildsystem=cmake

.PHONY: override_dh_auto_configure override_dh_auto_test \
	override_dh_auto_install override_dh_missing

## rocksdb 9.11.2

=== debian/changelog ===
rocksdb (9.11.2-1) unstable; urgency=medium

  [ Otto Kekäläinen ]
  * New upstream release 9.11.2, see details at
    - https://github.com/facebook/rocksdb/releases/tag/v9.11.2
  * This is the last RocksDB release in 9.x series. Next version in Debian will
    be the latest 10.x version which includes breaking API changes.
  * Library transition from librocksdb9.10 to librocksdb9.11
  * Update Debian copyright for 2026
  * Drop redundant `Rules-Requires-Root: no`
  * Drop redundant `Priority: optional`
  * Bump Debian Policy version
  * Update d/watch to use uscan v5 syntax
  * Apply `debputy reformat --style black`
  * Extend MIPS adaptations to apply to all remaining architectures
    (Closes: #1111226)

  [ Michael R. Crusoe ]
  * d/README.source.md: fix typo: `--add-upstream-vcs`
  * d/control: to simplify maintenance, enable building on any architecture
    except sparc64 and ppc64

 -- Otto Kekäläinen <otto@debian.org>  Wed, 14 Jan 2026 16:55:50 +0000

rocksdb (9.10.0-2) unstable; urgency=medium

  [ Adrian Bunk <bunk@debian.org> ]
  * Backport upstream fixes for FTBFS with GCC 15 (closes: #1097799).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 05 Jan 2026 22:14:40 +0100

=== debian/control ===
--- 
+++ 
@@ -1,33 +1,32 @@
 Source: rocksdb
 Section: database
-Priority: optional
 Maintainer: Laszlo Boszormenyi (GCS) <gcs@debian.org>
 Uploaders:
  Laszlo Boszormenyi (GCS) <gcs@debian.org>,
  Otto Kekäläinen <otto@debian.org>,
 Build-Depends:
+ debhelper-compat (= 13),
  cmake,
- debhelper-compat (= 13),
  libbz2-dev,
  libgflags-dev,
  liblz4-dev,
  libsnappy-dev,
  libzstd-dev,
  zlib1g-dev,
-Standards-Version: 4.7.0
-Rules-Requires-Root: no
+ do-not-build-on-these-archs [sparc64 ppc64]
+Standards-Version: 4.7.3
 Homepage: https://rocksdb.org/
 Vcs-Browser: https://salsa.debian.org/debian/rocksdb
 Vcs-Git: https://salsa.debian.org/debian/rocksdb.git
 
 Package: librocksdb-dev
 Section: libdevel
-Architecture: amd64 arm64 armel armhf i386 loong64 mips mips64el mipsel ppc64el riscv64 s390x
+Architecture: any
 Depends:
  libbz2-dev,
  libgflags-dev,
  liblz4-dev,
- librocksdb9.10 (= ${binary:Version}),
+ librocksdb9.11 (= ${binary:Version}),
  libsnappy-dev,
  libzstd-dev,
  zlib1g-dev,
@@ -56,9 +55,9 @@
  This package contains libraries and header files for developing
  applications that use librocksdb .
 
-Package: librocksdb9.10
+Package: librocksdb9.11
 Section: libs
-Architecture: amd64 arm64 armel armhf i386 loong64 mips mips64el mipsel ppc64el riscv64 s390x
+Architecture: any
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
@@ -84,7 +83,7 @@
      processors
 
 Package: rocksdb-tools
-Architecture: amd64 arm64 armel armhf i386 loong64 mips mips64el mipsel ppc64el riscv64 s390x
+Architecture: any
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},

=== debian/watch ===
Version: 5

Template: Github
Dversion-Mangle: s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//
Owner: facebook
Project: rocksdb
Uversion-Mangle: s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|b|a)[\-\.]?\d*)$/$1~$2/

## rocksdb py-0.0.1

=== benchmark/cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

project(rocksdb_bench)

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release)
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wall")
set(CMAKE_CXX_FLAGS_DEBUG "-g")
set(CMAKE_CXX_FLAGS_RELEASE "-O3")

find_package(Rocksdb)

if((NOT ROCKSDB_FOUND))
  find_path(ROCKSDB_ROOT_DIR NAMES include/rocksdb/db.h)

  find_library(
    ROCKSDB_LIBRARIES
    NAMES rocksdb
    HINTS ${ROCKSDB_ROOT_DIR})

  find_path(
    ROCKSDB_INCLUDE_DIR
    NAMES rocksdb/db.h
    HINTS ${ROCKSDB_ROOT_DIR}/include)

  include(FindPackageHandleStandardArgs)

  find_package_handle_standard_args(Rocksdb DEFAULT_MSG ROCKSDB_LIBRARIES
                                    ROCKSDB_INCLUDE_DIR)

  mark_as_advanced(ROCKSDB_ROOT_DIR ROCKSDB_LIBRARIES ROCKSDB_INCLUDE_DIR)
endif()

file(GLOB SOURCES "src/*.h" "src/*.cpp")

message(STATUS "Library is ${ROCKSDB_LIBRARIES}")
message(STATUS "Includes is ${ROCKSDB_INCLUDE_DIR}")

include_directories(${ROCKSDB_INCLUDE_DIR})

add_executable(${PROJECT_NAME} ${SOURCES})
target_link_libraries(${PROJECT_NAME} ${ROCKSDB_LIBRARIES})

=== benchmark/python/requirements.txt ===
rocksdb-py==0.0.1
